package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.data.domain.Sort.Direction;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.orm.jpa.JpaSystemException;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.MasterProgramKerjaStrategisConverter;
import com.jasamedika.medifirst2000.dao.MasterProgramKerjaStrategisDao;
import com.jasamedika.medifirst2000.entities.MasterProgramKerjaStrategis;
import com.jasamedika.medifirst2000.exception.ServiceVOException;
import com.jasamedika.medifirst2000.service.MasterProgramKerjaStrategisService;
import com.jasamedika.medifirst2000.vo.MasterProgramKerjaStrategisVO;

@Service("MasterProgramKerjaStrategisService")
public class MasterProgramKerjaStrategisServiceImpl extends BaseVoServiceImpl implements MasterProgramKerjaStrategisService{

	@Autowired
	private MasterProgramKerjaStrategisDao programDao;
	
	@Autowired
	private MasterProgramKerjaStrategisConverter programConverter;
	
	@Override
	public MasterProgramKerjaStrategisVO add(MasterProgramKerjaStrategisVO vo)
			throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public MasterProgramKerjaStrategisVO update(MasterProgramKerjaStrategisVO vo)
			throws JpaSystemException, ServiceVOException {
		return null;
	}

	@Override
	public Boolean delete(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public MasterProgramKerjaStrategisVO findById(Integer key) throws JpaSystemException {
		return null;
	}

	@Override
	public List<MasterProgramKerjaStrategisVO> findAll() throws JpaSystemException {
		return null;
	}

	@Override
	public Map<String, Object> findAllWithPageAndLimitAndSortByAndDirectionParameter(Integer page, Integer limit,
			String sort, String dir) {
		return null;
	}

	@Override
	public Map<String, Object> findAll(Integer page, Integer take, String sort, String dir,
			Specification<MasterProgramKerjaStrategis> spec) {
		Direction direction=null;
		
		if(dir.equalsIgnoreCase("asc")){
			direction=Sort.Direction.ASC;
		}else{
			direction=Sort.Direction.DESC;
		}
		
		Pageable pageable = new PageRequest(page, take, direction, sort);
		Page<MasterProgramKerjaStrategis> resultPage = programDao.findAll(spec, pageable);
		List<MasterProgramKerjaStrategis> resultData = resultPage.getContent();
		return constructMapReturn(resultData, resultPage.getTotalElements(), resultPage.getTotalPages());
	}

	@Override
	public Map<String, Object> save(MasterProgramKerjaStrategisVO vo) {
		Map<String,Object> result = new HashMap<String,Object>();
		MasterProgramKerjaStrategis model = programConverter.transferVOToModel(vo, new MasterProgramKerjaStrategis());
		
		programDao.save(model);
		
		return result;
	}

}
